/*
btgetblk.c Version 0.1.0  Btree read database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void btgetblk(bthdr,ofst)
btreefmt *bthdr;
off_t ofst;
   {
   off_t loc;
   int rdlen;
   bthdr->reason = 0;
   loc = btseek(bthdr,ofst);
   if (bthdr->reason) return;
   rdlen = read(bthdr->hndl,bthdr->blk,bthdr->blksz);
   if (rdlen == bthdr->blksz)
      {
      bthdr->ofst = ofst;
      return;
      } /* good read */
   else if (rdlen < 0)
      {
      fprintf(stderr,"btgetblk: error reading database "
	 "ofst %08x blksz %d rdlen %d)\n",
	 (unsigned int) ofst,
	 bthdr->blksz, rdlen);
      fprintf(stderr,"hndl %d loc %08x errno %d\n",
	 bthdr->hndl,
	 (unsigned int) loc,
	 errno);
      perror("Read error");
      bthdr->reason = SYS_ERR + errno;
      return;
      } /* read err */
   else
      {
      fprintf(stderr,"btgetblk: error reading database "
	 "ofst %08x blksz %d rdlen %d)\n",
	 (unsigned int) ofst,
	 bthdr->blksz, rdlen);
      bthdr->reason = BTREE_ERR + 1301;
      return;
      } /* read err */
   } /* btgetblk */
